$(document).ready(function() {
				  					
	$(".message").each(function() {
					   
		// PREVIEW //
		$(this).children("input").change(function() {
			var me = $(this);
			var uuid = me.attr("uuid");
			var parent = me.parent();
			var previewField = parent.children(".outputTextPreview");
			
			// now let's create the param string for our POST
			var formFieldPostString = BuildParamString(uuid, parent, previewField);
			if (formFieldPostString != null) {
				// post the string, asking the server for the preview string using these token fields
				$.ajax({
					type: "POST",
					url: "/html/message/preview",
					data: formFieldPostString,
					cache: false,
					success: function(html) {
						previewField.html(html);
					}
				});
			}
		});
		
		// SENDING //
		$(this).children(".messageTitleContainer").children(".sendButton").click(function() {
			var me = $(this);
			var uuid = me.attr("uuid");
			var message = me.parents(".message");
			
			var paramString = BuildParamString(uuid, message, null);
			me.addClass("animateOut");
																		
			var checkMark = me.parent().children(".sendSuccessCheckmark");
						
			// post the string, asking the server for the preview string using these token fields
			$.ajax({
				type: "POST",
				url: "/html/message/send",
				data: paramString,
				cache: false,
				success: function(html) {
				   checkMark.addClass("bounceIn").delay(500).fadeOut(500, function() {
						me.removeClass("animateOut").show();
				   });
				}
			});
		});
	});
});


function BuildParamString(uuid, messageElement, previewField) {
	var formFieldParamString = 'uuid='+ uuid + '+';
	
	var fields = messageElement.children("input");
	var numberOfFields = fields.length;
	var fieldsWithValues = 0;
	fields.each(function(index, element) {
				var thisField = $(this);
				var textValue = thisField.val();
				var tokenName = thisField.attr("placeholder"); // token names are used as the text field placeholder
				var encodedParam = encodeURIComponent(tokenName) + "=";
				if (textValue.length) {
					encodedParam += encodeURIComponent(textValue);
					fieldsWithValues++;
					} else {
						encodedParam += 'null';
					}
					
					formFieldParamString += encodedParam;
					
					if (index != (numberOfFields-1)) { // if this isn't the last input, append a plus between this and the next param
						formFieldParamString += "+";
					}
				});
	
	if (previewField != null) {
		if (fieldsWithValues > 0) {
			previewField.addClass("previewEnabled");
		} else {
			previewField.html("Output Preview");
			previewField.removeClass("previewEnabled");
			return null;
		}
	}
	
	return formFieldParamString;
}
